#pragma comment (lib, "User32.lib")

#include <stdio.h>
#include <process.h>

/* 
	To compile 32bit dll:
	cl.exe /D_USRDLL /D_WINDLL version.cpp /link /DLL /OUT:version.dll
	
	"C:\Program Files (x86)\Microsoft Visual Studio 14.0\VC\vcvarsall.bat" amd64
	cl.exe /D_USRDLL /D_WINDLL version.cpp /link /DLL /OUT:version.dll
*/

/* export all required functions - use Dependency Walker to check what is needed */
extern "C"
  {
   __declspec(dllexport) int GetFileVersionInfoA();
__declspec(dllexport) int GetFileVersionInfoByHandle();
__declspec(dllexport) int GetFileVersionInfoExW();
__declspec(dllexport) int GetFileVersionInfoSizeA();
__declspec(dllexport) int GetFileVersionInfoSizeExW();
__declspec(dllexport) int GetFileVersionInfoSizeW();
__declspec(dllexport) int GetFileVersionInfoW();
__declspec(dllexport) int VerFindFileA();
__declspec(dllexport) int VerFindFileW();
__declspec(dllexport) int VerInstallFileA();
__declspec(dllexport) int VerInstallFileW();
__declspec(dllexport) int VerLanguageNameA();
__declspec(dllexport) int VerLanguageNameW();
__declspec(dllexport) int VerQueryValueA();
__declspec(dllexport) int VerQueryValueW();
  }

/* 
	Implement DLLMain with common datatypes so we don't have to include windows.h. 
	Otherwise this would cause several compile errors because of the already known but reexported functions.
*/
int DllMain(void* hinst, unsigned long* reason, void* reserved) {
	system("cmd /c \"date >> C:\\this_should_not_work.txt\"");
	exit(1);
	return 0;
}

int GetFileVersionInfoA() {
	printf("Call to GetFileVersionInfoA");
	system("cmd /c \"echo GetFileVersionInfoA>%tmp%\\dll_log\"");
	return 0;
}
int GetFileVersionInfoByHandle() {
	printf("Call to GetFileVersionInfoByHandle");
	system("cmd /c \"echo GetFileVersionInfoByHandle>%tmp%\\dll_log\"");
	return 0;
}
int GetFileVersionInfoExW() {
	printf("Call to GetFileVersionInfoExW");
	system("cmd /c \"echo GetFileVersionInfoExW>%tmp%\\dll_log\"");
	return 0;
}
int GetFileVersionInfoSizeA() {
	printf("Call to GetFileVersionInfoSizeA");
	system("cmd /c \"echo GetFileVersionInfoSizeA>%tmp%\\dll_log\"");
	return 0;
}
int GetFileVersionInfoSizeExW() {
	printf("Call to GetFileVersionInfoSizeExW");
	system("cmd /c \"echo GetFileVersionInfoSizeExW>%tmp%\\dll_log\"");
	return 0;
}
int GetFileVersionInfoSizeW() {
	printf("Call to GetFileVersionInfoSizeW");
	system("cmd /c \"echo GetFileVersionInfoSizeW>%tmp%\\dll_log\"");
	return 0;
}
int GetFileVersionInfoW() {
	printf("Call to GetFileVersionInfoW");
	system("cmd /c \"echo GetFileVersionInfoW>%tmp%\\dll_log\"");
	return 0;
}
int VerFindFileA() {
	printf("Call to VerFindFileA");
	system("cmd /c \"echo VerFindFileA>%tmp%\\dll_log\"");
	return 0;
}
int VerFindFileW() {
	printf("Call to VerFindFileW");
	system("cmd /c \"echo VerFindFileW>%tmp%\\dll_log\"");
	return 0;
}
int VerInstallFileA() {
	printf("Call to VerInstallFileA");
	system("cmd /c \"echo VerInstallFileA>%tmp%\\dll_log\"");
	return 0;
}
int VerInstallFileW() {
	printf("Call to VerInstallFileW");
	system("cmd /c \"echo VerInstallFileW>%tmp%\\dll_log\"");
	return 0;
}
int VerLanguageNameA() {
	printf("Call to VerLanguageNameA");
	system("cmd /c \"echo VerLanguageNameA>%tmp%\\dll_log\"");
	return 0;
}
int VerLanguageNameW() {
	printf("Call to VerLanguageNameW");
	system("cmd /c \"echo VerLanguageNameW>%tmp%\\dll_log\"");
	return 0;
}
int VerQueryValueA() {
	printf("Call to VerQueryValueA");
	system("cmd /c \"echo VerQueryValueA>%tmp%\\dll_log\"");
	return 0;
}
int VerQueryValueW() {
	printf("Call to VerQueryValueW");
	system("cmd /c \"echo VerQueryValueW>%tmp%\\dll_log\"");
	return 0;
}




